#include "mainwindow.h"
#include "ui_mainwindow.h"
#include <bcm2835.h>
#include "carteAPIIO.h"
#include "carteAPIAN.h"

#define clk_div BCM2835_I2C_CLOCK_DIVIDER_2500



MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    carteIO1 = new carteAPIIO(); // Instanciation d'une carte API IO
    carteAN1 = new carteAPIAN(); // Instanciation d'une carte API AN

    // Paramétrage ComboBox IO
    ui->comboBox->addItem("0x20");
    ui->comboBox->addItem("0x21");
    ui->comboBox->addItem("0x22");
    ui->comboBox->addItem("0x23");
    ui->comboBox->addItem("0x24");
    ui->comboBox->addItem("0x25");
    ui->comboBox->addItem("0x26");
    ui->comboBox->addItem("0x27");
    ui->comboBox->setItemData(4,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox->setItemData(5,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox->setItemData(6,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox->setItemData(7,QBrush(Qt::red),Qt::TextColorRole);

    // Paramétrage ComboBox AN
    ui->comboBox_2->addItem("0x14");
    ui->comboBox_2->addItem("0x15");
    ui->comboBox_2->addItem("0x16");
    ui->comboBox_2->addItem("0x17");
    ui->comboBox_2->addItem("0x24");
    ui->comboBox_2->addItem("0x25");
    ui->comboBox_2->addItem("0x26");
    ui->comboBox_2->addItem("0x27");
    ui->comboBox_2->addItem("0x34");
    ui->comboBox_2->setItemData(4,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox_2->setItemData(5,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox_2->setItemData(6,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox_2->setItemData(7,QBrush(Qt::red),Qt::TextColorRole);


    ui->comboBox_3->addItem("0x14");
    ui->comboBox_3->addItem("0x15");
    ui->comboBox_3->addItem("0x16");
    ui->comboBox_3->addItem("0x17");
    ui->comboBox_3->addItem("0x24");
    ui->comboBox_3->addItem("0x25");
    ui->comboBox_3->addItem("0x26");
    ui->comboBox_3->addItem("0x27");
    ui->comboBox_3->addItem("0x34");
    ui->comboBox_3->setItemData(4,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox_3->setItemData(5,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox_3->setItemData(6,QBrush(Qt::red),Qt::TextColorRole);
    ui->comboBox_3->setItemData(7,QBrush(Qt::red),Qt::TextColorRole);

    char i2cOut[2];
 //   char i2cIn[22];
    unsigned int slave_address=0x20; // Adresse I2C par défaut
    bcm2835_init();
    bcm2835_i2c_begin();
   // QPixmap pix("image1.jpg");
   // ui->label_pic->setPixmap(pix);
    bcm2835_i2c_setSlaveAddress(slave_address);
    bcm2835_i2c_setClockDivider(clk_div);
/*    i2cOut[0]=0x00;  // 1er registre à lire dans le circuit

    // Configuration du Port A en entrée
    i2cOut[0]=0x00;     // adresse registre IODIRA
    i2cOut[1]=0xFF;     // Valeur du IODIRA
    bcm2835_i2c_write(i2cOut, 2); //

    // Configuration du Port B en sortie
    i2cOut[0]=0x01;     // adresse registre IODDRB
    i2cOut[1]=0x00;     // Valeur du IODIRB
    bcm2835_i2c_write(i2cOut, 2); //

    // Configuration par défaut des sorties relais à 0
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    i2cOut[1]=0x00;                 // stockage de la valeur 0 dans i2cOut[1]
    bcm2835_i2c_write(i2cOut, 2); 	// puis sortie de cette valeur sur GPIOB*/

    // Affichage par défaut de niveau 0 en entrées logiques
    ui->label_12->setNum(0);
    ui->label_14->setNum(0);
    ui->label_16->setNum(0);
    ui->label_18->setNum(0);
    ui->label_20->setNum(0);
    ui->label_22->setNum(0);
    ui->label_24->setNum(0);
    ui->label_26->setNum(0);


    T1 = new QTimer(this);
    T1->setInterval(500);
    connect(T1,SIGNAL(timeout()),this,SLOT(sltOnTimer()));
    T1->start();
}

MainWindow::~MainWindow()
{
    bcm2835_i2c_end();
    delete ui;
}

void MainWindow::sltOnTimer()
{

    char i2cOut[3];
    char i2cIn[4];
    unsigned int valeur;
    double valeur_tension;
    double valeur_courant;

    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    // Lecture des niveaux logiques sur le Port A
    i2cOut[0]=0x12;  				// adresse registre GPIOA
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    if ((i2cIn[0]&0b00000001)!=0) ui->label_12->setNum(1);
    else ui->label_12->setNum(0);
    if ((i2cIn[0]&0b00000010)!=0) ui->label_14->setNum(1);
    else ui->label_14->setNum(0);
    if ((i2cIn[0]&0b00000100)!=0) ui->label_16->setNum(1);
    else ui->label_16->setNum(0);
    if ((i2cIn[0]&0b00001000)!=0) ui->label_18->setNum(1);
    else ui->label_18->setNum(0);
    if ((i2cIn[0]&0b00010000)!=0) ui->label_20->setNum(1);
    else ui->label_20->setNum(0);
    if ((i2cIn[0]&0b00100000)!=0) ui->label_22->setNum(1);
    else ui->label_22->setNum(0);
    if ((i2cIn[0]&0b01000000)!=0) ui->label_24->setNum(1);
    else ui->label_24->setNum(0);
    if ((i2cIn[0]&0b10000000)!=0) ui->label_26->setNum(1);
    else ui->label_26->setNum(0);

    // Récupération de l'adresse I2C pour la carte AN U2
    bcm2835_i2c_setSlaveAddress(carteAN1->getAdresseU2());

    // Gestion CH0

    if (carteAN1->CH0_5V())
        {
            i2cOut[0]=0xB0;                 // Valide ADC, mode single, ch0
            i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
            bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
            bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
            bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
            if (i2cIn[0]>191)
                {
                this->ui->label_33->setText("> PE !");  // Tension supérieure à pleine échaelle
                this->ui->label_34->setText(" ");       // Effacement de l'unité
                }
            else if (i2cIn[0]<128) this->ui->label_33->setText("0V aj"); // OV ajusté si tension très légèrement négative
            else
                {
                valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                //  this->ui->label_33->setNum(valeur_tension);
                QString str = QString::number(valeur_tension,'g',3);
                this->ui->label_33->setText(str);
                this->ui->label_34->setText("V");
                // this->ui->label_33->setText("0-5V");
                }
        }

    else if (carteAN1->CH0_10V())
        {
            i2cOut[0]=0xB0;                 // Valide ADC, mode single, ch0
            i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
            bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
            bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
            bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
            if (i2cIn[0]>191)
                {
                this->ui->label_33->setText("> PE !");  // Tension supérieure à pleine échaelle
                this->ui->label_34->setText(" ");       // Effacement de l'unité
                }
            else if (i2cIn[0]<128) this->ui->label_33->setText("0V aj"); // OV ajusté si tension très légèrement négative
            else
                {
                valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                //this->ui->label_33->setNum(valeur_tension);
                QString str = QString::number(valeur_tension,'g',3);
                this->ui->label_33->setText(str);
                this->ui->label_34->setText("V");
                // this->ui->label_33->setText("0-10V");
                }
        }

    else if (carteAN1->CH0_4_20mA())
        {
            i2cOut[0]=0xB0;                 // Valide ADC, mode single, ch0
            i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
            bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
            bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
            bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
            if (i2cIn[0]>191)
                {
                this->ui->label_33->setText("> PE !");  // Tension supérieure à pleine échaelle
                this->ui->label_34->setText(" ");       // Effacement de l'unité
                }
            else if (i2cIn[0]<128)
                {
                this->ui->label_33->setText("0 aj"); // OV ajusté si tension très légèrement négative
                this->ui->label_34->setText(" ");    // Effacement de l'unité
                }
            else
                {
                valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                    {
                    this->ui->label_33->setText("0 aj");
                    this->ui->label_34->setText(" ");    // Effacement de l'unité
                    }
                else
                    {
                //this->ui->label_33->setNum(valeur_tension);
                QString str = QString::number(valeur_courant,'g',3);
                this->ui->label_33->setText(str);
                this->ui->label_34->setText("mA");
                //this->ui->label_33->setText("4-20mA");
                    }
                }
        }

    //------------------------------

        bcm2835_delay(100);             // Délais entre 2 conversions

    //------------------------------
    // Gestion CH1
        if (carteAN1->CH1_5V())
            {
                i2cOut[0]=0xB8;                 // Valide ADC, mode single, ch0
                i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                if (i2cIn[0]>191)
                    {
                    this->ui->label_37->setText("> PE !");  // Tension supérieure à pleine échaelle
                    this->ui->label_35->setText(" ");       // Effacement de l'unité
                    }
                else if (i2cIn[0]<128) this->ui->label_37->setText("0V aj"); // OV ajusté si tension très légèrement négative
                else
                    {
                    valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                    valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                    QString str = QString::number(valeur_tension,'g',3);
                    this->ui->label_37->setText(str);
                    this->ui->label_35->setText("V");
                    }
            }

        else if (carteAN1->CH1_10V())
            {
                i2cOut[0]=0xB8;                 // Valide ADC, mode single, ch0
                i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                if (i2cIn[0]>191)
                    {
                    this->ui->label_37->setText("> PE !");  // Tension supérieure à pleine échaelle
                    this->ui->label_35->setText(" ");       // Effacement de l'unité
                    }
                else if (i2cIn[0]<128) this->ui->label_37->setText("0V aj"); // OV ajusté si tension très légèrement négative
                else
                    {
                    valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                    valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                    QString str = QString::number(valeur_tension,'g',3);
                    this->ui->label_37->setText(str);
                    this->ui->label_35->setText("V");
                    }
            }

        else if (carteAN1->CH1_4_20mA())
            {
                i2cOut[0]=0xB8;                 // Valide ADC, mode single, ch0
                i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                if (i2cIn[0]>191)
                    {
                    this->ui->label_37->setText("> PE !");  // Tension supérieure à pleine échaelle
                    this->ui->label_35->setText(" ");       // Effacement de l'unité
                    }
                else if (i2cIn[0]<128)
                    {
                    this->ui->label_37->setText("0 aj"); // OV ajusté si tension très légèrement négative
                    this->ui->label_35->setText(" ");    // Effacement de l'unité
                    }
                else
                    {
                    valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                    valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                    valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                    if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                        {
                        this->ui->label_37->setText("0 aj");
                        this->ui->label_35->setText(" ");    // Effacement de l'unité
                        }
                    else
                        {
                    QString str = QString::number(valeur_courant,'g',3);
                    this->ui->label_37->setText(str);
                    this->ui->label_35->setText("mA");
                         }
                    }
            }

        //------------------------------

            bcm2835_delay(100);             // Délais entre 2 conversions

        //------------------------------
        // Gestion CH2
            if (carteAN1->CH2_5V())
                {
                    i2cOut[0]=0xB1;                 // Valide ADC, mode single, ch0
                    i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                    bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                    bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                    bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                    if (i2cIn[0]>191)
                        {
                        this->ui->label_40->setText("> PE !");  // Tension supérieure à pleine échaelle
                        this->ui->label_38->setText(" ");       // Effacement de l'unité
                        }
                    else if (i2cIn[0]<128) this->ui->label_40->setText("0V aj"); // OV ajusté si tension très légèrement négative
                    else
                        {
                        valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                        valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                        QString str = QString::number(valeur_tension,'g',3);
                        this->ui->label_40->setText(str);
                        this->ui->label_38->setText("V");
                        }
                }

            else if (carteAN1->CH2_10V())
                {
                    i2cOut[0]=0xB1;                 // Valide ADC, mode single, ch0
                    i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                    bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                    bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                    bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                    if (i2cIn[0]>191)
                        {
                        this->ui->label_40->setText("> PE !");  // Tension supérieure à pleine échaelle
                        this->ui->label_38->setText(" ");       // Effacement de l'unité
                        }
                    else if (i2cIn[0]<128) this->ui->label_40->setText("0V aj"); // OV ajusté si tension très légèrement négative
                    else
                        {
                        valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                        valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                        QString str = QString::number(valeur_tension,'g',3);
                        this->ui->label_40->setText(str);
                        this->ui->label_38->setText("V");
                        }
                }

            else if (carteAN1->CH2_4_20mA())
                {
                    i2cOut[0]=0xB1;                 // Valide ADC, mode single, ch0
                    i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                    bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                    bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                    bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                    if (i2cIn[0]>191)
                        {
                        this->ui->label_40->setText("> PE !");  // Tension supérieure à pleine échaelle
                        this->ui->label_38->setText(" ");       // Effacement de l'unité
                        }
                    else if (i2cIn[0]<128)
                        {
                        this->ui->label_40->setText("0 aj"); // OV ajusté si tension très légèrement négative
                        this->ui->label_38->setText(" ");    // Effacement de l'unité
                        }
                    else
                        {
                        valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                        valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                        valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                        if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                            {
                            this->ui->label_40->setText("0 aj");
                            this->ui->label_38->setText(" ");    // Effacement de l'unité
                            }
                        else
                            {
                        QString str = QString::number(valeur_courant,'g',3);
                        this->ui->label_40->setText(str);
                        this->ui->label_38->setText("mA");
                             }
                        }
                }

            //------------------------------

                bcm2835_delay(100);             // Délais entre 2 conversions

            //------------------------------
            // Gestion CH3
                if (carteAN1->CH3_5V())
                    {
                        i2cOut[0]=0xB9;                 // Valide ADC, mode single, ch0
                        i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                        bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                        bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                        bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                        if (i2cIn[0]>191)
                            {
                            this->ui->label_43->setText("> PE !");  // Tension supérieure à pleine échaelle
                            this->ui->label_41->setText(" ");       // Effacement de l'unité
                            }
                        else if (i2cIn[0]<128) this->ui->label_43->setText("0V aj"); // OV ajusté si tension très légèrement négative
                        else
                            {
                            valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                            valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                            QString str = QString::number(valeur_tension,'g',3);
                            this->ui->label_43->setText(str);
                            this->ui->label_41->setText("V");
                            }
                    }

                else if (carteAN1->CH3_10V())
                    {
                        i2cOut[0]=0xB9;                 // Valide ADC, mode single, ch0
                        i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                        bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                        bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                        bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                        if (i2cIn[0]>191)
                            {
                            this->ui->label_43->setText("> PE !");  // Tension supérieure à pleine échaelle
                            this->ui->label_41->setText(" ");       // Effacement de l'unité
                            }
                        else if (i2cIn[0]<128) this->ui->label_41->setText("0V aj"); // OV ajusté si tension très légèrement négative
                        else
                            {
                            valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                            valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                            QString str = QString::number(valeur_tension,'g',3);
                            this->ui->label_43->setText(str);
                            this->ui->label_41->setText("V");
                            }
                    }

                else if (carteAN1->CH3_4_20mA())
                    {
                        i2cOut[0]=0xB9;                 // Valide ADC, mode single, ch0
                        i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                        bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                        bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                        bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                        if (i2cIn[0]>191)
                            {
                            this->ui->label_43->setText("> PE !");  // Tension supérieure à pleine échaelle
                            this->ui->label_41->setText(" ");       // Effacement de l'unité
                            }
                        else if (i2cIn[0]<128)
                            {
                            this->ui->label_43->setText("0 aj"); // OV ajusté si tension très légèrement négative
                            this->ui->label_41->setText(" ");    // Effacement de l'unité
                            }
                        else
                            {
                            valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                            valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                            valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                            if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                                {
                                this->ui->label_43->setText("0 aj");
                                this->ui->label_41->setText(" ");    // Effacement de l'unité
                                }
                            else
                                {
                            QString str = QString::number(valeur_courant,'g',3);
                            this->ui->label_43->setText(str);
                            this->ui->label_41->setText("mA");
                                 }
                            }
                    }

                //------------------------------

                    bcm2835_delay(100);             // Délais entre 2 conversions

                //------------------------------


                // Récupération de l'adresse I2C pour la carte AN U3
                bcm2835_i2c_setSlaveAddress(carteAN1->getAdresseU3());

                // Gestion CH4

                if (carteAN1->CH4_5V())
                    {
                        i2cOut[0]=0xB0;                 // Valide ADC, mode single, ch0
                        i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                        bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                        bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                        bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                        if (i2cIn[0]>191)
                            {
                            this->ui->label_52->setText("> PE !");  // Tension supérieure à pleine échaelle
                            this->ui->label_45->setText(" ");       // Effacement de l'unité
                            }
                        else if (i2cIn[0]<128) this->ui->label_52->setText("0V aj"); // OV ajusté si tension très légèrement négative
                        else
                            {
                            valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                            valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                            //  this->ui->label_33->setNum(valeur_tension);
                            QString str = QString::number(valeur_tension,'g',3);
                            this->ui->label_52->setText(str);
                            this->ui->label_45->setText("V");
                            // this->ui->label_33->setText("0-5V");
                            }
                    }

                else if (carteAN1->CH4_10V())
                    {
                        i2cOut[0]=0xB0;                 // Valide ADC, mode single, ch0
                        i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                        bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                        bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                        bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                        if (i2cIn[0]>191)
                            {
                            this->ui->label_52->setText("> PE !");  // Tension supérieure à pleine échaelle
                            this->ui->label_45->setText(" ");       // Effacement de l'unité
                            }
                        else if (i2cIn[0]<128) this->ui->label_52->setText("0V aj"); // OV ajusté si tension très légèrement négative
                        else
                            {
                            valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                            valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                            //this->ui->label_33->setNum(valeur_tension);
                            QString str = QString::number(valeur_tension,'g',3);
                            this->ui->label_52->setText(str);
                            this->ui->label_45->setText("V");
                            // this->ui->label_33->setText("0-10V");
                            }
                    }

                else if (carteAN1->CH4_4_20mA())
                    {
                        i2cOut[0]=0xB0;                 // Valide ADC, mode single, ch0
                        i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                        bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                        bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                        bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                        if (i2cIn[0]>191)
                            {
                            this->ui->label_52->setText("> PE !");  // Tension supérieure à pleine échaelle
                            this->ui->label_45->setText(" ");       // Effacement de l'unité
                            }
                        else if (i2cIn[0]<128)
                            {
                            this->ui->label_52->setText("0 aj"); // OV ajusté si tension très légèrement négative
                            this->ui->label_45->setText(" ");    // Effacement de l'unité
                            }
                        else
                            {
                            valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                            valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                            valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                            if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                                {
                                this->ui->label_52->setText("0 aj");
                                this->ui->label_45->setText(" ");    // Effacement de l'unité
                                }
                            else
                                {
                            //this->ui->label_33->setNum(valeur_tension);
                            QString str = QString::number(valeur_courant,'g',3);
                            this->ui->label_52->setText(str);
                            this->ui->label_45->setText("mA");
                            //this->ui->label_33->setText("4-20mA");
                                }
                            }
                    }

                //------------------------------

                    bcm2835_delay(100);             // Délais entre 2 conversions

                //------------------------------
                // Gestion CH5
                    if (carteAN1->CH5_5V())
                        {
                            i2cOut[0]=0xB8;                 // Valide ADC, mode single, ch0
                            i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                            bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                            bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                            bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                            if (i2cIn[0]>191)
                                {
                                this->ui->label_48->setText("> PE !");  // Tension supérieure à pleine échaelle
                                this->ui->label_49->setText(" ");       // Effacement de l'unité
                                }
                            else if (i2cIn[0]<128) this->ui->label_48->setText("0V aj"); // OV ajusté si tension très légèrement négative
                            else
                                {
                                valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                                QString str = QString::number(valeur_tension,'g',3);
                                this->ui->label_48->setText(str);
                                this->ui->label_49->setText("V");
                                }
                        }

                    else if (carteAN1->CH5_10V())
                        {
                            i2cOut[0]=0xB8;                 // Valide ADC, mode single, ch0
                            i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                            bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                            bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                            bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                            if (i2cIn[0]>191)
                                {
                                this->ui->label_48->setText("> PE !");  // Tension supérieure à pleine échaelle
                                this->ui->label_49->setText(" ");       // Effacement de l'unité
                                }
                            else if (i2cIn[0]<128) this->ui->label_48->setText("0V aj"); // OV ajusté si tension très légèrement négative
                            else
                                {
                                valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                                QString str = QString::number(valeur_tension,'g',3);
                                this->ui->label_48->setText(str);
                                this->ui->label_49->setText("V");
                                }
                        }

                    else if (carteAN1->CH5_4_20mA())
                        {
                            i2cOut[0]=0xB8;                 // Valide ADC, mode single, ch0
                            i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                            bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                            bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                            bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                            if (i2cIn[0]>191)
                                {
                                this->ui->label_48->setText("> PE !");  // Tension supérieure à pleine échaelle
                                this->ui->label_49->setText(" ");       // Effacement de l'unité
                                }
                            else if (i2cIn[0]<128)
                                {
                                this->ui->label_48->setText("0 aj"); // OV ajusté si tension très légèrement négative
                                this->ui->label_49->setText(" ");    // Effacement de l'unité
                                }
                            else
                                {
                                valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                                valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                                if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                                    {
                                    this->ui->label_48->setText("0 aj");
                                    this->ui->label_49->setText(" ");    // Effacement de l'unité
                                    }
                                else
                                    {
                                QString str = QString::number(valeur_courant,'g',3);
                                this->ui->label_48->setText(str);
                                this->ui->label_49->setText("mA");
                                     }
                                }
                        }

                    //------------------------------

                        bcm2835_delay(100);             // Délais entre 2 conversions

                    //------------------------------
                    // Gestion CH6
                        if (carteAN1->CH6_5V())
                            {
                                i2cOut[0]=0xB1;                 // Valide ADC, mode single, ch0
                                i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                                bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                                bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                                bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                                if (i2cIn[0]>191)
                                    {
                                    this->ui->label_54->setText("> PE !");  // Tension supérieure à pleine échaelle
                                    this->ui->label_50->setText(" ");       // Effacement de l'unité
                                    }
                                else if (i2cIn[0]<128) this->ui->label_54->setText("0V aj"); // OV ajusté si tension très légèrement négative
                                else
                                    {
                                    valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                    valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                                    QString str = QString::number(valeur_tension,'g',3);
                                    this->ui->label_54->setText(str);
                                    this->ui->label_50->setText("V");
                                    }
                            }

                        else if (carteAN1->CH6_10V())
                            {
                                i2cOut[0]=0xB1;                 // Valide ADC, mode single, ch0
                                i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                                bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                                bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                                bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                                if (i2cIn[0]>191)
                                    {
                                    this->ui->label_54->setText("> PE !");  // Tension supérieure à pleine échaelle
                                    this->ui->label_50->setText(" ");       // Effacement de l'unité
                                    }
                                else if (i2cIn[0]<128) this->ui->label_54->setText("0V aj"); // OV ajusté si tension très légèrement négative
                                else
                                    {
                                    valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                    valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                                    QString str = QString::number(valeur_tension,'g',3);
                                    this->ui->label_54->setText(str);
                                    this->ui->label_50->setText("V");
                                    }
                            }

                        else if (carteAN1->CH6_4_20mA())
                            {
                                i2cOut[0]=0xB1;                 // Valide ADC, mode single, ch0
                                i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                                bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                                bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                                bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                                if (i2cIn[0]>191)
                                    {
                                    this->ui->label_54->setText("> PE !");  // Tension supérieure à pleine échaelle
                                    this->ui->label_50->setText(" ");       // Effacement de l'unité
                                    }
                                else if (i2cIn[0]<128)
                                    {
                                    this->ui->label_54->setText("0 aj"); // OV ajusté si tension très légèrement négative
                                    this->ui->label_50->setText(" ");    // Effacement de l'unité
                                    }
                                else
                                    {
                                    valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                    valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                                    valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                                    if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                                        {
                                        this->ui->label_54->setText("0 aj");
                                        this->ui->label_50->setText(" ");    // Effacement de l'unité
                                        }
                                    else
                                        {
                                    QString str = QString::number(valeur_courant,'g',3);
                                    this->ui->label_54->setText(str);
                                    this->ui->label_50->setText("mA");
                                         }
                                    }
                            }

                        //------------------------------

                            bcm2835_delay(100);             // Délais entre 2 conversions

                        //------------------------------
                        // Gestion CH7
                            if (carteAN1->CH7_5V())
                                {
                                    i2cOut[0]=0xB9;                 // Valide ADC, mode single, ch0
                                    i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                                    bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                                    bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                                    bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                                    if (i2cIn[0]>191)
                                        {
                                        this->ui->label_44->setText("> PE !");  // Tension supérieure à pleine échaelle
                                        this->ui->label_47->setText(" ");       // Effacement de l'unité
                                        }
                                    else if (i2cIn[0]<128) this->ui->label_44->setText("0V aj"); // OV ajusté si tension très légèrement négative
                                    else
                                        {
                                        valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                        valeur_tension=((double)valeur*5)/65535;    // Calcul de la tension équivalente avec amplification de 2
                                        QString str = QString::number(valeur_tension,'g',3);
                                        this->ui->label_44->setText(str);
                                        this->ui->label_47->setText("V");
                                        }
                                }

                            else if (carteAN1->CH7_10V())
                                {
                                    i2cOut[0]=0xB9;                 // Valide ADC, mode single, ch0
                                    i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                                    bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                                    bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                                    bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                                    if (i2cIn[0]>191)
                                        {
                                        this->ui->label_44->setText("> PE !");  // Tension supérieure à pleine échaelle
                                        this->ui->label_47->setText(" ");       // Effacement de l'unité
                                        }
                                    else if (i2cIn[0]<128) this->ui->label_44->setText("0V aj"); // OV ajusté si tension très légèrement négative
                                    else
                                        {
                                        valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                        valeur_tension=((double)valeur*10)/65535;    // Calcul de la tension équivalente avec amplification de 4
                                        QString str = QString::number(valeur_tension,'g',3);
                                        this->ui->label_44->setText(str);
                                        this->ui->label_47->setText("V");
                                        }
                                }

                            else if (carteAN1->CH7_4_20mA())
                                {
                                    i2cOut[0]=0xB9;                 // Valide ADC, mode single, ch0
                                    i2cOut[1]=0x88;                 // Entrée externe, gain 1, speed2
                                    bcm2835_i2c_write(i2cOut, 2); 	// Ecriture dans l'ADC
                                    bcm2835_delay(100);             // Tempo supérieure à celle de la conversion
                                    bcm2835_i2c_read(i2cIn, 3); 	// Lecture des 3 octets du résultat
                                    if (i2cIn[0]>191)
                                        {
                                        this->ui->label_44->setText("> PE !");  // Tension supérieure à pleine échaelle
                                        this->ui->label_47->setText(" ");       // Effacement de l'unité
                                        }
                                    else if (i2cIn[0]<128)
                                        {
                                        this->ui->label_44->setText("0 aj"); // OV ajusté si tension très légèrement négative
                                        this->ui->label_47->setText(" ");    // Effacement de l'unité
                                        }
                                    else
                                        {
                                        valeur=((i2cIn[2]>>6) + (4*i2cIn[1]) + 1024*(i2cIn[0]&0b00111111)); // Mise en forme et calcul de la valeur reçue
                                        valeur_tension=((double)valeur*2.5)/65535;    // Calcul de la tension équivalente
                                        valeur_courant=valeur_tension*1000/125; // Exprimé en milliampères
                                        if (valeur_courant<0.1) // Intensité négligeable mais non nulle
                                            {
                                            this->ui->label_44->setText("0 aj");
                                            this->ui->label_47->setText(" ");    // Effacement de l'unité
                                            }
                                        else
                                            {
                                        QString str = QString::number(valeur_courant,'g',3);
                                        this->ui->label_44->setText(str);
                                        this->ui->label_47->setText("mA");
                                             }
                                        }
                                }


}

void MainWindow::on_radioButton_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 0 -> mise à 0 du bit 0 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b11111110;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_2_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 0 -> mise à 1 du bit 0 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b00000001;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}


void MainWindow::on_radioButton_3_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 1 -> mise à 0 du bit 1 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b11111101;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_4_clicked()
{

    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 1 -> mise à 1 du bit 1 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b00000010;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_5_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 2 -> mise à 0 du bit 2 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b11111011;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_6_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 2 -> mise à 1 du bit 2 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b00000100;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_7_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 3 -> mise à 0 du bit 3 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b11110111;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_8_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 3 -> mise à 1 du bit 3 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b00001000;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_9_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 4 -> mise à 0 du bit 4 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b11101111;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_10_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 4 -> mise à 1 du bit 4 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b00010000;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_15_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 5 -> mise à 0 du bit 5 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b11011111;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_16_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 5 -> mise à 1 du bit 5 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b00100000;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_13_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 6 -> mise à 0 du bit 6 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b10111111;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_14_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 6 -> mise à 1 du bit 6 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b01000000;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_11_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos du relais 7 -> mise à 0 du bit 7 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]&0b01111111;  // Forçage à 0 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_radioButton_12_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail du relais 7 -> mise à 1 du bit 7 du PortB
    char i2cOut[2];
    char i2cIn[2];
    // Lecture du registre B
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    bcm2835_i2c_write(i2cOut, 1); 	//
    bcm2835_i2c_read(i2cIn, 1); 	// Lecture de la valeur se trouvant sur GPIOA dans i2cIn[0]
    i2cOut[1]=i2cIn[0]|0b10000000;  // Forçage à 1 du bit concerné
    bcm2835_i2c_write(i2cOut, 2);   // Sortie de la valeur modifiée sur GPIOB
}

void MainWindow::on_pushButton_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au repos des 8 relais -> mise à 0 de tout le PortB
    char i2cOut[2];

    // Configuration des sorties relais à 0
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    i2cOut[1]=0x00;                 // stockage de la valeur 0 dans i2cOut[1]
    bcm2835_i2c_write(i2cOut, 2); 	// puis sortie de cette valeur sur GPIOB

    //Rénitialisation radioButton
    this->ui->radioButton->setChecked(true);
    this->ui->radioButton_2->setChecked(false);
    this->ui->radioButton_3->setChecked(true);
    this->ui->radioButton_4->setChecked(false);
    this->ui->radioButton_5->setChecked(true);
    this->ui->radioButton_6->setChecked(false);
    this->ui->radioButton_7->setChecked(true);
    this->ui->radioButton_8->setChecked(false);
    this->ui->radioButton_9->setChecked(true);
    this->ui->radioButton_10->setChecked(false);
    this->ui->radioButton_11->setChecked(true);
    this->ui->radioButton_12->setChecked(false);
    this->ui->radioButton_13->setChecked(true);
    this->ui->radioButton_14->setChecked(false);
    this->ui->radioButton_15->setChecked(true);
    this->ui->radioButton_16->setChecked(false);
}

void MainWindow::on_pushButton_2_clicked()
{
    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Mise au travail des 8 relais -> mise à 1 de tout le PortB
    char i2cOut[2];

    // Configuration des sorties relais à 1
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    i2cOut[1]=0xFF;                 // stockage de la valeur 0xFF dans i2cOut[1]
    bcm2835_i2c_write(i2cOut, 2); 	// puis sortie de cette valeur sur GPIOB

    //Rénitialisation radioButton
    this->ui->radioButton->setChecked(false);
    this->ui->radioButton_2->setChecked(true);
    this->ui->radioButton_3->setChecked(false);
    this->ui->radioButton_4->setChecked(true);
    this->ui->radioButton_5->setChecked(false);
    this->ui->radioButton_6->setChecked(true);
    this->ui->radioButton_7->setChecked(false);
    this->ui->radioButton_8->setChecked(true);
    this->ui->radioButton_9->setChecked(false);
    this->ui->radioButton_10->setChecked(true);
    this->ui->radioButton_11->setChecked(false);
    this->ui->radioButton_12->setChecked(true);
    this->ui->radioButton_13->setChecked(false);
    this->ui->radioButton_14->setChecked(true);
    this->ui->radioButton_15->setChecked(false);
    this->ui->radioButton_16->setChecked(true);
}

void MainWindow::on_comboBox_activated(int index)
{
    // Affectation de l'adresse I2C carte IO
    if (index==0) carteIO1->setAdresse(0x20);
    if (index==1) carteIO1->setAdresse(0x21);
    if (index==2) carteIO1->setAdresse(0x22);
    if (index==3) carteIO1->setAdresse(0x23);
    if (index==4) carteIO1->setAdresse(0x24);
    if (index==5) carteIO1->setAdresse(0x25);
    if (index==6) carteIO1->setAdresse(0x26);
    if (index==7) carteIO1->setAdresse(0x27);

    // Récupération de l'adresse I2C pour la carte IO
    bcm2835_i2c_setSlaveAddress(carteIO1->getAdresse());

    //Configuration des registres de direction des Ports A et B
    char i2cOut[2];
    char i2cIn[2];

    // Configuration du Port A en entrée
    i2cOut[0]=0x00;     // adresse registre IODIRA
    i2cOut[1]=0xFF;     // Valeur du IODIRA
    bcm2835_i2c_write(i2cOut, 2); //

    // Configuration du Port B en sortie
    i2cOut[0]=0x01;     // adresse registre IODDRB
    i2cOut[1]=0x00;     // Valeur du IODIRB
    bcm2835_i2c_write(i2cOut, 2); //

/*    // Configuration par défaut des sorties relais à 0
    i2cOut[0]=0x13;                 // adresse registre GPIOB
    i2cOut[1]=0x00;                 // stockage de la valeur 0 dans i2cOut[1]
    bcm2835_i2c_write(i2cOut, 2); 	// puis sortie de cette valeur sur GPIOB*/
}

void MainWindow::on_comboBox_2_activated(int index)
{
    // Affectation de l'adresse I2C carte AN Circuit U2
    if (index==0) carteAN1->setAdresseU2(0x14);
    if (index==1) carteAN1->setAdresseU2(0x15);
    if (index==2) carteAN1->setAdresseU2(0x16);
    if (index==3) carteAN1->setAdresseU2(0x17);
    if (index==4) carteAN1->setAdresseU2(0x24);
    if (index==5) carteAN1->setAdresseU2(0x25);
    if (index==6) carteAN1->setAdresseU2(0x26);
    if (index==7) carteAN1->setAdresseU2(0x27);
    if (index==8) carteAN1->setAdresseU2(0x34);
}

void MainWindow::on_comboBox_3_activated(int index)
{
    // Affectation de l'adresse I2C carte AN Circuit U3
    if (index==0) carteAN1->setAdresseU3(0x14);
    if (index==1) carteAN1->setAdresseU3(0x15);
    if (index==2) carteAN1->setAdresseU3(0x16);
    if (index==3) carteAN1->setAdresseU3(0x17);
    if (index==4) carteAN1->setAdresseU3(0x24);
    if (index==5) carteAN1->setAdresseU3(0x25);
    if (index==6) carteAN1->setAdresseU3(0x26);
    if (index==7) carteAN1->setAdresseU3(0x27);
    if (index==8) carteAN1->setAdresseU3(0x34);
}

void MainWindow::on_radioButton_17_clicked()
{
    this->ui->label_34->setText("V");
    carteAN1->setCH0_5V(true);
    carteAN1->setCH0_10V(false);
    carteAN1->setCH0_4_20mA(false);
}

void MainWindow::on_radioButton_18_clicked()
{
    this->ui->label_34->setText("V");
    carteAN1->setCH0_5V(false);
    carteAN1->setCH0_10V(true);
    carteAN1->setCH0_4_20mA(false);
}

void MainWindow::on_radioButton_19_clicked()
{
    this->ui->label_34->setText("mA");
    carteAN1->setCH0_5V(false);
    carteAN1->setCH0_10V(false);
    carteAN1->setCH0_4_20mA(true);
}

void MainWindow::on_radioButton_20_clicked()
{
    this->ui->label_35->setText("V");
    carteAN1->setCH1_5V(true);
    carteAN1->setCH1_10V(false);
    carteAN1->setCH1_4_20mA(false);
}

void MainWindow::on_radioButton_21_clicked()
{
    this->ui->label_35->setText("V");
    carteAN1->setCH1_5V(false);
    carteAN1->setCH1_10V(true);
    carteAN1->setCH1_4_20mA(false);
}

void MainWindow::on_radioButton_22_clicked()
{
    this->ui->label_35->setText("mA");
    carteAN1->setCH1_5V(false);
    carteAN1->setCH1_10V(false);
    carteAN1->setCH1_4_20mA(true);
}

void MainWindow::on_radioButton_23_clicked()
{
    this->ui->label_38->setText("V");
    carteAN1->setCH2_5V(true);
    carteAN1->setCH2_10V(false);
    carteAN1->setCH2_4_20mA(false);
}

void MainWindow::on_radioButton_24_clicked()
{
    this->ui->label_38->setText("V");
    carteAN1->setCH2_5V(false);
    carteAN1->setCH2_10V(true);
    carteAN1->setCH2_4_20mA(false);
}

void MainWindow::on_radioButton_25_clicked()
{
    this->ui->label_38->setText("mA");
    carteAN1->setCH2_5V(false);
    carteAN1->setCH2_10V(false);
    carteAN1->setCH2_4_20mA(true);
}

void MainWindow::on_radioButton_26_clicked()
{
    this->ui->label_41->setText("V");
    carteAN1->setCH3_5V(true);
    carteAN1->setCH3_10V(false);
    carteAN1->setCH3_4_20mA(false);
}

void MainWindow::on_radioButton_27_clicked()
{
    this->ui->label_41->setText("V");
    carteAN1->setCH3_5V(false);
    carteAN1->setCH3_10V(true);
    carteAN1->setCH3_4_20mA(false);
}

void MainWindow::on_radioButton_28_clicked()
{
    this->ui->label_41->setText("mA");
    carteAN1->setCH3_5V(false);
    carteAN1->setCH3_10V(false);
    carteAN1->setCH3_4_20mA(true);
}

void MainWindow::on_radioButton_35_clicked()
{
    this->ui->label_45->setText("V");
    carteAN1->setCH4_5V(true);
    carteAN1->setCH4_10V(false);
    carteAN1->setCH4_4_20mA(false);
}

void MainWindow::on_radioButton_36_clicked()
{
    this->ui->label_45->setText("V");
    carteAN1->setCH4_5V(false);
    carteAN1->setCH4_10V(true);
    carteAN1->setCH4_4_20mA(false);
}

void MainWindow::on_radioButton_37_clicked()
{
    this->ui->label_45->setText("mA");
    carteAN1->setCH4_5V(false);
    carteAN1->setCH4_10V(false);
    carteAN1->setCH4_4_20mA(true);
}

void MainWindow::on_radioButton_29_clicked()
{
    this->ui->label_49->setText("V");
    carteAN1->setCH5_5V(true);
    carteAN1->setCH5_10V(false);
    carteAN1->setCH5_4_20mA(false);
}

void MainWindow::on_radioButton_30_clicked()
{
    this->ui->label_49->setText("V");
    carteAN1->setCH5_5V(false);
    carteAN1->setCH5_10V(true);
    carteAN1->setCH5_4_20mA(false);
}

void MainWindow::on_radioButton_31_clicked()
{
    this->ui->label_49->setText("mA");
    carteAN1->setCH5_5V(false);
    carteAN1->setCH5_10V(false);
    carteAN1->setCH5_4_20mA(true);
}

void MainWindow::on_radioButton_32_clicked()
{
    this->ui->label_50->setText("V");
    carteAN1->setCH6_5V(true);
    carteAN1->setCH6_10V(false);
    carteAN1->setCH6_4_20mA(false);
}

void MainWindow::on_radioButton_33_clicked()
{
    this->ui->label_50->setText("V");
    carteAN1->setCH6_5V(false);
    carteAN1->setCH6_10V(true);
    carteAN1->setCH6_4_20mA(false);
}

void MainWindow::on_radioButton_34_clicked()
{
    this->ui->label_50->setText("mA");
    carteAN1->setCH6_5V(false);
    carteAN1->setCH6_10V(false);
    carteAN1->setCH6_4_20mA(true);
}

void MainWindow::on_radioButton_38_clicked()
{
    this->ui->label_47->setText("V");
    carteAN1->setCH7_5V(true);
    carteAN1->setCH7_10V(false);
    carteAN1->setCH7_4_20mA(false);
}

void MainWindow::on_radioButton_39_clicked()
{
    this->ui->label_47->setText("V");
    carteAN1->setCH7_5V(false);
    carteAN1->setCH7_10V(true);
    carteAN1->setCH7_4_20mA(false);
}

void MainWindow::on_radioButton_40_clicked()
{
    this->ui->label_47->setText("mA");
    carteAN1->setCH7_5V(false);
    carteAN1->setCH7_10V(false);
    carteAN1->setCH7_4_20mA(true);
}




